/*
  UIDES.CPP
  Main source file for class TDescriptor


  Copyright (c) 1994 by Borland International
  All Rights Reserved

  This source code is hereby released into the public domain.
  Written by Jeffrey J. Peters

*/

#include <dos.h>

#include "uiclass.h"

TDescriptor::~TDescriptor (void)
{
  Free ();
}

int TDescriptor::SetBase (bits32 b)
{
  PUSH_BX
  _BX = index;
  _AX = 7;
  _CX = ((bits16 *)&b)[1];
  _DX = ((bits16 *)&b)[0];
  geninterrupt (0x31);
  POP_BX
  if (_FLAGS&1)
  {
    return -1;
  }
  base = b;
  return 0;
}
int TDescriptor::SetLimit (bits32 l)
{
  PUSH_BX
  _BX = index;
  _AX = 8;
  _CX = ((bits16 *)&l)[1];
  _DX = ((bits16 *)&l)[0];
  geninterrupt (0x31);
  POP_BX
  if (_FLAGS&1)
  {
    return -1;
  }
  limit = l;
  return 0;
}
int TDescriptor::SetRights (bits08 r)
{
  bits16 s = index;
  PUSH_BX
#ifdef __DPMI32__
  _CH = Get32Rights (index);
#else
  _CH = 0;
#endif
  _CL = r;
  _BX = s;
  _AX = 9;
  geninterrupt (0x31);
  POP_BX
  if (_FLAGS&1)
  {
    return -1;
  }
  rights = r;
  return 0;
}
int TDescriptor::Allocate (void)
{
  bits16 s;

  _AX = 0;
  _CX = 1;
  geninterrupt (0x31);
  s = _AX;
  if (_FLAGS&1)
  {
    return -1;
  }
  index = s;
  allocated = 1;
  return 0;
}

int TDescriptor::Free (void)
{
  if (!allocated)
    return -1;

  PUSH_BX
  _AX = 1;
  _BX = index;
  geninterrupt (0x31);
  POP_BX
  if (_FLAGS&1)
  {
    return -1;
  }
  allocated = 0;
  return 0;
}
